<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xalan="http://xml.apache.org/xslt">
    
    <xsl:output method="html"/>
    
    <xsl:template match="/">
		<html>
			<head><title>Products</title></head>
			<body>
				<xsl:variable name="priceSum">
					<xsl:call-template name="priceSum">
						<xsl:with-param name="productList" select="/*/Product"/>
					</xsl:call-template>
				</xsl:variable>
								
				<table border="1">
					<tr>
						<td><b>Name</b></td>
						<td><b>Price</b></td>
					</tr>
					<xsl:for-each select="/Products/Product">
						<tr>
							<td><xsl:value-of select="Name"/></td>
							<td><xsl:value-of select="Price"/></td>
						</tr>
					</xsl:for-each>
					<tr>
						<td align="right"><b>Simple - Total Price:</b></td>
						<td><b><xsl:value-of select="concat('$',$priceSum)"/></b></td>
					</tr>
				</table>
			</body>
		</html>
    </xsl:template>
    
    <xsl:template name="priceSum">
    	<xsl:param name="productList"/>
    	<xsl:choose>
    		<xsl:when test="$productList">
    			<xsl:variable name="recursive_result">
    				<xsl:call-template name="priceSum">
    					<xsl:with-param name="productList" select="$productList[position() &gt; 1]"/>
    				</xsl:call-template>
    			</xsl:variable>
    			<xsl:value-of select="number(substring-after($productList[1]/Price,'$')) + $recursive_result"/>
    		</xsl:when>
    		<xsl:otherwise><xsl:value-of select="0"/></xsl:otherwise>
    	</xsl:choose>
    </xsl:template>
    </xsl:stylesheet>
    
    