<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" >
   
    <xsl:template match="/">
            <!-- On appelle le template rechercheMax -->
            <xsl:call-template name="RechercheMax">
                <!-- On initialise le max avec la valeur du premier élément number -->
                <xsl:with-param name="max"><xsl:value-of select=".//number[1]"/></xsl:with-param>
                <!-- On commence donc par comparer le max avec le deuxième élément -->
                <xsl:with-param name="indice">2</xsl:with-param>
        </xsl:call-template>
    </xsl:template>
    
    <xsl:template name="RechercheMax">
        <!-- liste des paramètres -->
        <xsl:param name="max"></xsl:param> 
        <xsl:param name="indice"></xsl:param>
       <!-- On teste si on a atteint le dernier élément number -->
        <xsl:choose>
            <xsl:when test="$indice= count(//number)">
                <!-- On teste si la valeur de l'élément corant est supérieur à max -->
                <xsl:choose>
                    <xsl:when test="//number[position() = $indice] &gt; $max">
                        <!-- On affiche le résultat -->
                        <xsl:value-of select="//number[position() = $indice]"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <!-- On affiche le résultat -->
                        <xsl:value-of select="$max"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when> 
            <!-- si l'élément courant n'est pas le dernier de la liste -->
             <xsl:otherwise>
                 <!-- On teste si la valeur de l'élément corant est supérieur à max -->
                <xsl:choose>
                    <xsl:when test="//number[position() = $indice] &gt; $max">
                        <!-- on rapelle le template avec la nouvelle valeur de max et on incrémente l'indice -->
                        <xsl:call-template name="RechercheMax">
                            <xsl:with-param name="max"><xsl:value-of select="//number[position() = $indice]"/></xsl:with-param>
                            <xsl:with-param name="indice"><xsl:value-of select="$indice +1"/></xsl:with-param>
                        </xsl:call-template>
                    </xsl:when>
                    <xsl:otherwise>
                        <!-- on rapelle le template, on incrémente l'indice -->
                        <xsl:call-template name="RechercheMax">
                            <xsl:with-param name="max"><xsl:value-of select="$max"/></xsl:with-param>
                            <xsl:with-param name="indice"><xsl:value-of select="$indice +1"/></xsl:with-param>
                        </xsl:call-template>
                    </xsl:otherwise>
                </xsl:choose>
                </xsl:otherwise>
        </xsl:choose> 
    </xsl:template>
    
</xsl:stylesheet>

