<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
   <xsl:template match="/">
   	<html><body bgcolor="#ffffff">
      <xsl:apply-templates select="scrabble/joueurs/joueur" />

      <xsl:apply-templates select="scrabble/reste" />

      <xsl:apply-templates select="scrabble/plateau" />
      </body>
      </html>
   </xsl:template>

<!-- afficher le reste-->
   <xsl:template match="reste">
      <h2>il reste 
      <xsl:value-of select="sum(lettre/nombre/@num)" />

      lettres</h2>
   </xsl:template>

<!-- afficher joueurs -->
   <xsl:template match="joueur">
      <h2>joueur 
      <xsl:value-of select="nom/text()" />
      </h2>

      <table>
         <tr>
            <xsl:apply-templates select="lettre" mode="colonne" />
         </tr>
      </table>
   </xsl:template>

<!-- affiche une colonne et la lettre -->
   <xsl:template match="lettre" mode="colonne">
      <td>
         <xsl:apply-templates select="." />
      </td>
   </xsl:template>

<!-- afficher le plateau , apple methode de parcours-->
   <xsl:template match="plateau">
      <table border="1">
         <xsl:apply-templates select="." mode="parcours_colonne">
            <xsl:with-param name="y" select="1" />
         </xsl:apply-templates>
      </table>
   </xsl:template>

<!-- afficher colonne -->
   <xsl:template match="plateau" mode="parcours_colonne">
      <xsl:param name="y" />

      <xsl:choose>
         <xsl:when test="not($y=taille/@y + 1)">
         
            <xsl:apply-templates select="." mode="parcours_ligne">
               <xsl:with-param name="x" select="0" />
               <xsl:with-param name="y" select="$y" />
            </xsl:apply-templates>
            <xsl:apply-templates select="." mode="parcours_colonne">
            	<xsl:with-param name="y" select="$y + 1"/>
            </xsl:apply-templates>
         </xsl:when>
         
      </xsl:choose>
   </xsl:template>

<!-- afficher lettre en parcourant le plateau -->
   <xsl:template match="plateau" mode="parcours_ligne">
      <xsl:param name="x" />
      <xsl:param name="y" />
      

<!-- afficher la structure du tableau -->
      <xsl:choose>
         <xsl:when test="$x=0">
            <tr height="80">
               
               <xsl:apply-templates select="." mode="parcours_ligne">
                  <xsl:with-param name="x" select="1" />
                  <xsl:with-param name="y" select="$y" />
               </xsl:apply-templates>
            </tr>
         </xsl:when>

         <xsl:otherwise>
            <xsl:if test="not($x=taille/@x + 1)">
               <td width="80">
               <center>
               <xsl:if test="not(lettres/lettre[position/@x=$x and position/@y=$y])">
               &#160;
               </xsl:if>
               <xsl:apply-templates select="lettres/lettre[position/@x=$x and position/@y=$y]"/>
               </center>
               </td>

               <xsl:apply-templates select="." mode="parcours_ligne">
                  <xsl:with-param name="x" select="$x + 1" />
                  <xsl:with-param name="y" select="$y" />
               </xsl:apply-templates>
            </xsl:if>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>

<!-- afficher une lettre du plateau -->
   <xsl:template match="lettre">
      <table border="0" bgcolor="#bbbbbb" width="50">
         <tr height="30">
            <td>
               <center>
                  <font size="7">

                  <xsl:value-of select="texte/@l" />
                  </font>
               </center>
            </td>
         </tr>

         <tr>
            <td align="right">
               <xsl:value-of select="/scrabble/valeurs/valeur[@l=current()/texte/@l]/@num" />
            </td>
         </tr>
      </table>
   </xsl:template>
</xsl:stylesheet>

