<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" >
    <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
    
    <!-- conversion en binaire d'une liste d'entier positifs-->
    <xsl:template match="/">
        <xsl:element name="ListeNombreBinaire">
                <xsl:for-each select="//nombre">
                    <xsl:element name="nombreBinaire">
                        <xsl:attribute name="VD">
                            <xsl:value-of select="."/>
                        </xsl:attribute>
                        <xsl:choose>
                            <xsl:when test=". &lt; 0">
                                <xsl:value-of select="'le nombre doit être un entier naturel'"/>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:call-template name="transformationBinaire">
                                      <xsl:with-param name="nb" select="."/>
                                </xsl:call-template>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:element>
                </xsl:for-each>   
        </xsl:element>
    </xsl:template>
    
    <xsl:template name="transformationBinaire">
        <xsl:param name="nb"></xsl:param>
        <xsl:choose>
            <xsl:when test="$nb &lt; 2">
                <xsl:value-of select="$nb"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:call-template name="transformationBinaire">
                    <xsl:with-param name="nb" select="($nb - ($nb mod 2)) div 2"/> <!-- division euclidienne -->
                </xsl:call-template>
                <xsl:value-of select="$nb mod 2"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
</xsl:stylesheet>

